## ros-indigo-joint-trajectory-controller 0.9.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(joint_trajectory_controller)

# Load catkin and all dependencies required for this package
find_package(catkin
  REQUIRED COMPONENTS
    actionlib
    angles
    cmake_modules
    roscpp
    urdf
    control_toolbox
    controller_interface
    hardware_interface
    realtime_tools
    control_msgs
    trajectory_msgs
    controller_manager
    xacro
)

# Declare catkin package
catkin_package(
  CATKIN_DEPENDS
  actionlib
  angles
  roscpp
  urdf
  control_toolbox
  controller_interface
  hardware_interface
  realtime_tools
  control_msgs
  trajectory_msgs
  controller_manager
  xacro
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(include ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME} src/joint_trajectory_controller.cpp
                            include/joint_trajectory_controller/hardware_interface_adapter.h
                            include/joint_trajectory_controller/init_joint_trajectory.h
                            include/joint_trajectory_controller/joint_trajectory_controller.h
                            include/joint_trajectory_controller/joint_trajectory_controller_impl.h
                            include/joint_trajectory_controller/joint_trajectory_msg_utils.h
                            include/joint_trajectory_controller/joint_trajectory_segment.h
                            include/joint_trajectory_controller/tolerances.h
                            include/trajectory_interface/trajectory_interface.h
                            include/trajectory_interface/quintic_spline_segment.h
                            include/trajectory_interface/pos_vel_acc_state.h)

target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})


if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  catkin_add_gtest(quintic_spline_segment_test test/quintic_spline_segment_test.cpp)
  target_link_libraries(quintic_spline_segment_test ${catkin_LIBRARIES})

  catkin_add_gtest(trajectory_interface_test test/trajectory_interface_test.cpp)
  target_link_libraries(trajectory_interface_test ${catkin_LIBRARIES})

  catkin_add_gtest(joint_trajectory_segment_test test/joint_trajectory_segment_test.cpp)
  target_link_libraries(joint_trajectory_segment_test ${catkin_LIBRARIES})

  catkin_add_gtest(joint_trajectory_msg_utils_test test/joint_trajectory_msg_utils_test.cpp)
  target_link_libraries(joint_trajectory_msg_utils_test ${catkin_LIBRARIES})

  catkin_add_gtest(init_joint_trajectory_test test/init_joint_trajectory_test.cpp)
  target_link_libraries(init_joint_trajectory_test ${catkin_LIBRARIES})

  add_rostest_gtest(tolerances_test
                  test/tolerances.test
                  test/tolerances_test.cpp)
  target_link_libraries(tolerances_test ${catkin_LIBRARIES})

  add_executable(rrbot test/rrbot.cpp)
  target_link_libraries(rrbot ${catkin_LIBRARIES})

  add_executable(rrbot_wrapping test/rrbot_wrapping.cpp)
  target_link_libraries(rrbot_wrapping ${catkin_LIBRARIES})

  add_dependencies(tests rrbot)
  add_dependencies(tests rrbot_wrapping)
  add_dependencies(tests ${PROJECT_NAME})

  add_rostest_gtest(joint_trajectory_controller_test
                    test/joint_trajectory_controller.test
                    test/joint_trajectory_controller_test.cpp)
  target_link_libraries(joint_trajectory_controller_test ${catkin_LIBRARIES})

  add_rostest_gtest(joint_trajectory_controller_wrapping_test
                    test/joint_trajectory_controller_wrapping.test
                    test/joint_trajectory_controller_wrapping_test.cpp)
  target_link_libraries(joint_trajectory_controller_wrapping_test ${catkin_LIBRARIES})
endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY include/trajectory_interface/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/trajectory_interface/)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES ros_control_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

# TODO: Install test resource files as well?

=== debian/changelog ===
ros-indigo-joint-trajectory-controller (0.9.4-0trusty) trusty; urgency=high

  * Fix for issue #275 <https://github.com/ros-controls/roscontrollers/issues/275> (State error calculation not accounting for wrapping joint positions)
  * Contributors: bponsler

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 30 Jun 2017 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.9.3-0trusty) trusty; urgency=high

  * Add joint limits spec to rrbot test robot
  * Address -Wunused-parameter warnings
  * reset to semantic zero in HardwareInterfaceAdapter for PositionJointInterface
  * Contributors: Adolfo Rodriguez Tsouroukdissian, ipa-fxm

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 12 Feb 2016 00:00:00 -0000

ros-indigo-joint-trajectory-controller (0.9.2-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 03 May 2015 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.9.1-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-indigo-joint-trajectory-controller (0.9.0-0trusty) trusty; urgency=high

  * Check that waypoint times are strictly increasing before accepting a command
  * velocity_controllers::JointTrajectoryController: New plugin variant for
    velocity-controlled joints
  * Buildsystem fixes
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Lukas Bulwahn, ipa-fxm, Dave Coleman

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-indigo-joint-trajectory-controller (0.8.1-0trusty) trusty; urgency=high

  * joint_trajectory_controller: Critical targets declared before calling catkin_package
  * check for CATKIN_ENABLE_TESTING
  * Contributors: Jonathan Bohren, Lukas Bulwahn

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Thu, 10 Jul 2014 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.8.0-0trusty) trusty; urgency=high

  * Remove rosbuild artifacts. Fix #90 <https://github.com/ros-controls/ros_controllers/issues/90>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 11 May 2014 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.7.2-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 31 Mar 2014 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.7.1-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 30 Mar 2014 23:00:00 -0000

ros-indigo-joint-trajectory-controller (0.7.0-0trusty) trusty; urgency=high

  * Add support for an joint interfaces are not inherited from JointHandle.
  * Contributors: Igorec

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 28 Mar 2014 00:00:00 -0000

ros-indigo-joint-trajectory-controller (0.6.0-0trusty) trusty; urgency=high

  * Merge pull request #72 <https://github.com/ros-controls/ros_controllers/issues/72> from pal-robotics/minor-maintenance
    Minor maintenance
  * Default stop_trajectory_duration to zero. Refs #73 <https://github.com/ros-controls/ros_controllers/issues/73>
  * Better logs when dropping traj points. Refs #68 <https://github.com/ros-controls/ros_controllers/issues/68>.
  * Fix class member reorder warning in constructor.
  * Add missing headers to target files.
  * Action interface rejects empty goals. Fixes #70 <https://github.com/ros-controls/ros_controllers/issues/70>.
  * Reorder how time and traj data are updated.
    In the update method, fetching the currently executed trajectory should be done
    before updating the time data to prevent a potential scenario in which there
    is no trajectory defined for the current control cycle.
  * Work tolerance checking methods.
    Until now we used the currently active goal handle for performing tolerance
    checks. Using the goal handle stored in segments is more robust to unexpected
    goal updates by the non-rt thread.
  * Refactor how the currrent trajectory is stored.
    - Handle concurrency in the current trajectory between rt and non-rt threads
    using the simpler RealtimeBox instead of the RealtimeBuffer, because our
    usecase does not fit well the non-rt->writes / rt->reads semantics.
    - As a consequence we no longer need to store the msg_trajectory member, but
    only the hold_trajectory, which must still be preallocated.
  * Honor unspecified vel/acc in ROS message. Fix #65 <https://github.com/ros-controls/ros_controllers/issues/65>.
  * Fixes per Adolfo
  * Added verbose flag
  * Fixing realtime issues
  * Merge branch 'hydro-devel' into joint_trajectory_tweaks
  * Tweaked error messages
  * Added more debug info
  * Fix for microsecond delay that caused header time=0 (now) to start too late
  * Reworded debug message
  * Image update.
  * Update README.md
    Factor out user documentation to the ROS wiki.
  * Merge branch 'hydro-devel' of https://github.com/willowgarage/ros_controllers into hydro-devel
  * Rename hold_trajectory_duration
    - hold_trajectory_duration -> stop_trajectory_duration for more clarity.
    - During Hydro, hold_trajectory_duration will still work, giving a deprecation
    warning.
  * Add basic description in package.xml.
  * Add images used in the ROS wiki doc.
  * Added better debug info
  * Throttled debug output
  * Added more debug and error information
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-indigo-joint-trajectory-controller (0.5.4-0trusty) trusty; urgency=high

  * Added install rules for plugin.xml
  * Remove PID sign flip.
    This is now done in the state error computation.


=== debian/control ===
Source: ros-indigo-joint-trajectory-controller
Section: misc
Priority: extra
Maintainer: Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-actionlib, ros-indigo-angles, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-control-msgs, ros-indigo-control-toolbox, ros-indigo-controller-interface, ros-indigo-controller-manager, ros-indigo-hardware-interface, ros-indigo-realtime-tools, ros-indigo-roscpp, ros-indigo-rostest, ros-indigo-trajectory-msgs, ros-indigo-urdf, ros-indigo-xacro
Homepage: https://github.com/ros-controls/ros_controllers/wiki
Standards-Version: 3.9.2

Package: ros-indigo-joint-trajectory-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-actionlib, ros-indigo-angles, ros-indigo-control-msgs, ros-indigo-control-toolbox, ros-indigo-controller-interface, ros-indigo-controller-manager, ros-indigo-hardware-interface, ros-indigo-realtime-tools, ros-indigo-roscpp, ros-indigo-rostest, ros-indigo-rqt-plot, ros-indigo-trajectory-msgs, ros-indigo-urdf, ros-indigo-xacro
Description: Controller for executing joint-space trajectories on a group of joints.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-joint-trajectory-controller//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
